MODULE Numbermaze;

FROM AESApplications IMPORT ApplInitialise,ApplExit;
FROM AESGraphics IMPORT GrafHandle,GrafMouse,GrafMouseKeyboardState;
FROM VDIControls IMPORT ClearWorkstation,SetClipping,OpenVirtualWorkstation;
FROM RandomNumbers IMPORT Random;
FROM VDIOutputs IMPORT GraphicText,DrawRoundedBox,PolyLine;
FROM VDIAttribs IMPORT SetLineColour,SetGraphicTextColour,SetWritingMode;
FROM XBIOS IMPORT SetColour,GetResolution;
FROM Remaze IMPORT start,end,v,r1,w,h;
FROM BIOS IMPORT TimerCalibration;
FROM M2Conversions IMPORT ConvertInteger;
FROM GEMVDIbase IMPORT PxyArrayType,VDIWorkInType,VDIWorkOutType;
FROM NInit IMPORT fnumber,factor,Doit,DoAboutDialog;
FROM TextIO IMPORT WriteLn,Read,WriteString;
FROM GEMDOS IMPORT GetTime;
FROM Sounder IMPORT SoundOn,SoundOff,Sound;
FROM AESForms IMPORT FormAlert;

CONST width=10;
      height=14;
      wcell=28;hcell=12;
      
VAR End,Sol,Over,Quit : BOOLEAN;
   i,handle,Bx,By,oldspot,spot,k : INTEGER;
   numbers : ARRAY [0..600] OF INTEGER;
   oldsec,starttime,nowtime,min,sec: CARDINAL;
   a:ARRAY[0..4] OF CHAR;
   ch : CHAR;
   xy : PxyArrayType;
   k1: CARDINAL;
   c: ARRAY[0..5] OF CARDINAL;
   workin:VDIWorkInType;
   workout:VDIWorkOutType;
   
PROCEDURE Pauz(k : INTEGER);
VAR k1,j : INTEGER;
BEGIN
   FOR j := 0 TO k DO
       FOR k1 := 0 TO 200 DO END;
   END;
END Pauz;

PROCEDURE Beep;
BEGIN
   Sound(0,245,10,0,0); Pauz(400); Sound(0,0,0,0,0);
END Beep;

PROCEDURE Makemaze;
VAR i,j,k : INTEGER;
BEGIN
  ClearWorkstation(handle);
  SetClipping(handle,0,xy);DEC(end,width+1);
  FOR i:=0 TO height*(width+1) DO numbers[i]:=0;END;
  i:=start; j:=INTEGER(Random(98))+1;numbers[i]:=j;
  WHILE i<>end DO
    IF v[i]=2 THEN INC(i,width+1);
      ELSIF v[i]=4 THEN DEC(i,width+1);
      ELSIF v[i]=3 THEN INC(i);
      ELSIF v[i]=1 THEN DEC(i);
    END;
    j:=Getnumber(j);
    numbers[i]:=j;
  END;
  FOR i:=0 TO height*(width+1) DO 
    IF numbers[i] = 0 THEN
      numbers[i]:=INTEGER(Random(98))+1;
    END;
  END;
END Makemaze;

PROCEDURE Getnumber(j: INTEGER):INTEGER;
VAR k,j1 : INTEGER;
BEGIN
  REPEAT j1:=0; 
   k := INTEGER(Random(LONGCARD(fnumber+1)));
   IF k<4 THEN j1:=j+factor[k];
     ELSIF k<6 THEN j1:=j*factor[k];
     ELSE IF (j MOD factor[k])=0 THEN j1 := j DIV factor[k];END;
   END;
   UNTIL ((j1>0) AND (j1<100));
   RETURN(j1);
END Getnumber;

PROCEDURE Putit(spot,num : INTEGER);
VAR a : ARRAY [0..4] OF CHAR;
    i,j : INTEGER;
BEGIN
   i:=spot MOD (width+1);j:= spot DIV (width+1);
   IF i=0 THEN RETURN;END;
   ConvertInteger(num,3,a);
   GraphicText(handle,(wcell*i)-15,j*hcell+8,a)
END Putit;

PROCEDURE Makescreen;
VAR  i : INTEGER;
BEGIN
  i:=SetGraphicTextColour(handle,2);Makegrid;
  FOR i:= width+1 TO height*(width+1) DO 
    Putit(i,numbers[i]);
  END;
END Makescreen;

PROCEDURE Makegrid;
VAR i,j : INTEGER;
BEGIN
   i := SetLineColour(handle,4);
   xy[0]:=11;xy[1]:=10;xy[2]:=291;xy[3]:=10;
   FOR i:=1 TO 14 DO
      PolyLine(handle,2,xy);
      INC(xy[1],hcell);INC(xy[3],hcell);
   END;
   xy[0]:=11;xy[1]:=10;xy[2]:=11;xy[3]:=165;
   FOR i:=1 TO 11 DO
      PolyLine(handle,2,xy);
      INC(xy[0],wcell);INC(xy[2],wcell);
   END;
END Makegrid;
   
PROCEDURE Recolor(spot: INTEGER);
VAR  i : INTEGER;
BEGIN
  GrafMouse(256,NIL);
  i:=SetGraphicTextColour(handle,5);
  Putit(spot,numbers[spot]);
  i:=SetGraphicTextColour(handle,2);
  GrafMouse(257,NIL);
END Recolor;

PROCEDURE Makeboxes;
VAR 
    i : INTEGER;
BEGIN
  i := SetLineColour(handle,3);
  i := SetGraphicTextColour(handle,4);
  xy[0]:=20;xy[1]:=182;xy[2]:=80;xy[3]:=196;
  DrawRoundedBox(handle,xy);
  GraphicText(handle,30,191,"QUIT");
  xy[0]:=100;xy[2]:=180;
  DrawRoundedBox(handle,xy);
  GraphicText(handle,112,191,"RESTART");
END Makeboxes;

PROCEDURE Settimer;
BEGIN
  GrafMouse(256,NIL);
   GetTime(nowtime);
   sec:=nowtime MOD 100;
   IF sec<>oldsec THEN oldsec:=sec;
   i := SetGraphicTextColour(handle,0);
   GraphicText(handle,280,8,a);
      IF a[4]<>"8" THEN INC(a[4],2);
         ELSE a[4]:="0";
         IF a[3]<>"5" THEN INC(a[3]);
           ELSE a[3]:="0";
           IF a[1]<>"9" THEN INC(a[1]);
              ELSE a[1]:="0";INC(a[0]);
           END;
         END;
       END;
    i := SetGraphicTextColour(handle,5);
    GraphicText(handle,280,8,a);
    END;
  GrafMouse(257,NIL);
END Settimer;

PROCEDURE S1;
BEGIN
  GrafMouse(256,NIL);
  ClearWorkstation(handle);
  Makescreen;
  Recolor(start);Recolor(end);
  Makefactors;  Makeboxes;GrafMouse(257,NIL);
  GetTime(starttime);
  a:="00:00";  oldsec:=starttime MOD 100;
  GraphicText(handle,280,8,a);
  oldspot:=start;
END S1;

PROCEDURE Start;
BEGIN
  Doit;  r1;
  Makemaze;S1;  
END Start;

PROCEDURE Makefactors;
VAR af: ARRAY [0..7],[0..1] OF CHAR;
    i : INTEGER;
BEGIN
  FOR i:=0 TO 7 DO
    ConvertInteger(factor[i],1,af[i]);
  END;
  GraphicText(handle,220,180,"+");  GraphicText(handle,230,180,af[0]);
  GraphicText(handle,240,180,"+");  GraphicText(handle,250,180,af[1]);
  GraphicText(handle,265,180,af[2]);
  GraphicText(handle,285,180,af[3]);
  IF fnumber>4 THEN
  GraphicText(handle,220,190,"*");  GraphicText(handle,230,190,af[4]);
  GraphicText(handle,240,190,"*");  GraphicText(handle,250,190,af[5]);
  GraphicText(handle,265,190,"/");  GraphicText(handle,275,190,af[6]);
  GraphicText(handle,285,190,"/");  GraphicText(handle,295,190,af[7]);
  END;
END Makefactors;
  
PROCEDURE Goodmove(): BOOLEAN;
VAR i: INTEGER;
BEGIN
   IF By> 180 THEN
      IF Bx>210 THEN RETURN (FALSE);
      ELSIF Bx>100 THEN Over:=TRUE;RETURN (TRUE);
      ELSE Quit:=TRUE;RETURN TRUE;
      END;
   END;
   spot:=((Bx+15) DIV wcell)+(width+1)*((By-11) DIV hcell)+width+1;
   IF (ABS(spot-oldspot)=1) OR (ABS(spot-oldspot)=width+1) THEN
     FOR i:=0 TO 3 DO
       IF (numbers[spot]-numbers[oldspot])=factor[i] THEN RETURN (TRUE);
       END;
     END;
     IF fnumber>4  THEN
       FOR i:=4 TO 5 DO
         IF ((numbers[spot] DIV factor[i])=numbers[oldspot])
         AND ((numbers[spot] MOD factor[i])=0)  THEN 
         RETURN (TRUE);
         END;
       END;
       FOR i:=6 TO 7 DO
         IF (numbers[spot]*factor[i])=numbers[oldspot] THEN RETURN (TRUE);
         END;
       END;
     END;
   END;
   RETURN (FALSE);
END Goodmove;

PROCEDURE Solution;
VAR i : INTEGER;
BEGIN
  GrafMouse(256,NIL);  
  ClearWorkstation(handle);
  SetClipping(handle,0,xy);
  Makescreen;Makegrid;Makefactors;
  Recolor(start);Recolor(end);
  i:=start;
  WHILE i<>end DO
    IF v[i]=2 THEN INC(i,width+1);
      ELSIF v[i]=4 THEN DEC(i,width+1);
      ELSIF v[i]=3 THEN INC(i);
      ELSIF v[i]=1 THEN DEC(i);
    END;
    Recolor(i);Flicker(i);Flicker(i);Beep;
  END;
  GrafMouse(257,NIL);  
END Solution;

PROCEDURE Burp;
BEGIN
   Sound(0,685,10,0,0); Pauz(350); Sound(0,0,0,0,0);
END Burp;

PROCEDURE Flicker(sp:INTEGER);
BEGIN
  i:=SetGraphicTextColour(handle,0);
  Putit(sp,numbers[sp]);Pauz(100);
  i:=SetGraphicTextColour(handle,5);
  Putit(sp,numbers[sp]);Pauz(150);
END Flicker;

PROCEDURE Sparkle;
VAR i,k,oc,m : INTEGER;
BEGIN
  GrafMouse(256,NIL);  
   FOR k:=0 TO 150 DO
      oc:=(k MOD 5)+1;
      FOR i:=1 TO 5 DO
        INC(oc); IF oc>5 THEN oc:=1;END;
        m:=SetColour(i,c[oc]);
      END;  Pauz(45);
   END;
   oc:=0;
      FOR i:=1 TO 5 DO
        INC(oc) ; m:=SetColour(i,c[oc]);  END;
  GrafMouse(257,NIL);  
END Sparkle;

PROCEDURE Moveit (sp : INTEGER);
BEGIN
  GrafMouse(256,NIL);  
  Recolor(sp);
  GrafMouse(257,NIL);
END Moveit;

PROCEDURE Number;
BEGIN
  w:= width;h:=height;
  Over:=FALSE;Quit:=FALSE;Sol:=FALSE;
  ClearWorkstation(handle);i:=SetWritingMode(handle,1);
  Start; GrafMouse(257,NIL); Pauz(3000);
  i := SoundOn();SoundOff(i);
  LOOP
    Settimer;
    GrafMouseKeyboardState(Bx,By,k,i);
    IF k=1 THEN  k:=0;
       IF Goodmove() THEN  Beep;Pauz(150);Moveit(oldspot);Moveit(spot);
           oldspot:=spot;
       ELSE Burp;
       END;
    END;
    IF Over THEN S1;Over:=FALSE;  END;
    IF Quit THEN Quit:=FALSE;
       GrafMouse(256,NIL); 
       i:= DoAboutDialog(9); GrafMouse(257,NIL);  
        IF i=5 THEN Solution;END;
    RETURN;END;
    Flicker(oldspot);
    IF oldspot=end THEN Sparkle;RETURN;END;
  END;
END Number;

PROCEDURE AA;
BEGIN
  i:= ApplInitialise();
  i:=GetResolution();
  IF i<>0 THEN
   k1:=FormAlert(2,"[3][Game looks better in LOW Res][Quit|Continue]");
   IF k1=1 THEN RETURN;END;
  END;
  handle:=GrafHandle(i,i,i,i);
  FOR i:=0 TO 9 DO workin[i]:=1;END;workin[10]:=2;
  OpenVirtualWorkstation(workin,handle,workout);
  c[1]:=070H;c[2]:=777H;c[3]:=724H;c[4]:=070H;c[5]:=750H;
  k1:=SetColour(5,750H);  k1:=SetColour(0,515H);
  k1:=SetColour(1,070H);  k1:=SetColour(3,724H);
  k1:=SetColour(4,057H);
  LOOP
    Number;  GrafMouse(256,NIL);  
    ClearWorkstation(handle);WriteLn;
    WriteString("Do You wish to play again?");WriteLn;
    Read (ch);GrafMouse(257,NIL);  
    IF CAP(ch)<>"Y" THEN EXIT;END;
  END;  
END AA;

BEGIN
  AA;  ApplExit;
END Numbermaze.
    